import es, cfglib
import random

dm = es.import_addon('dm')

class Settings(object):
    config = cfglib.AddonCFG(dm.addondir + '/dm/addons/dissolve/settings.cfg')
    
    _dissolve      =  config.cvar('dm_dissolve', 6, 'Dissolver setting'), int # Needs fixing.
    config.text('Valid Dissolver Values [dm_dissolve]')
    config.text('0 = Disabled')
    config.text('1 = Remove ragdoll only (no effect)')
    config.text('2 = Energy Effect')
    config.text('3 = Heavy Electrical Effect')
    config.text('4 = Light Electrical Effect')
    config.text('5 = Core Effect')
    config.text('6 = Random')
    _dissolvedelay =  config.cvar('dm_dissolvedelay', 1, 'Delay before dissolving'), int
    
    config.execute()
    
    def __init__(self):
        self.config.write()
        
    def __getattr__(self, name):
        if hasattr(Settings, name):
            return super(Settings, self).__getattribute__(name)
           
        elif hasattr(Settings, '_'+name):
            val, func = super(Settings, self).__getattribute__('_'+name)
            return func(val)
           
        raise AttributeError, 'No such attribute "%s"'%name
        
settings = Settings()
        
        
def load():
    dm.msg('Loaded Addon - Dissolver')
    
def unload():
    dm.msg('Unloaded Addon - Dissolver')
        
        
def player_death(ev):
    dissolve(ev['userid'])
        
def dissolve(userid):
    type = settings.dissolve
    
    if type == 0:
        return
        
    d = settings.dissolvedelay
    
    if type == 6:
        type = random.randint(1, 6)
        
    if type == 1:
        es.delayed(d, 'es_xfire %s cs_ragdoll kill'%userid)
    else:       
        targetname = 'dissolve_%s'%userid
        index = es.createentity('env_entity_dissolver', targetname)
        es.entitysetvalue(index, 'target', 'cs_ragdoll')
        es.entitysetvalue(index, 'magnitude', '1')
        es.entitysetvalue(index, 'dissolvetype', str(type))
        es.spawnentity(index)
        es.delayed(d, 'es_xfire %s %s Dissolve'%(userid, targetname))